﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using C1.Web.Mvc;
using C1.Web.Mvc.Serialization;
using Microsoft.AspNetCore.Mvc;

namespace FlexGridIntro.Controllers
{
    public class Order
    {
        [Required]
        public int ID { get; set; }
        [Required]
        public string ProductName { get; set; }
        [Required]
        public DateTime Purchase { get; set; }
        [Required]
        public double Price { get; set; }
    }
    public class OrderDetail
    {   
        public Order Order { get; set; }
        [Required]
        public DateTime Shipped { get; set; }
        [Required]
        public DateTime OrderDate { get; set; }
        [Required]
        public DateTime DeliverDate { get; set; }
    }
    public class DeepBindController : Controller
    {
        public IActionResult Index()
        {
            var _item = new OrderDetail() { 
                 Order = new Order()
                    {  
                        ID= 001,
                        Price= 100.25,
                        ProductName= "ComponentOne",
                        Purchase= new DateTime()
                    },
                Shipped= new DateTime(),
                OrderDate= new DateTime(),
                DeliverDate= new DateTime()
            };
            var _i = new List<OrderDetail>();
            //_i.Add(_item);
            return View(_i);
        }

        public ActionResult BatchUpdate([C1JsonRequest] CollectionViewBatchEditRequest<OrderDetail> requestData)
        {
            var itemresults = new List<CollectionViewItemResult<OrderDetail>>();
            return this.C1Json(CollectionViewHelper.BatchEdit(requestData,
                batchData =>
                {

                    string error = string.Empty;
                    bool success = true;
                    try
                    {

                    }
                    catch (Exception e)
                    {
                        error = "ERRoR";
                        success = false;

                    }

                    return new CollectionViewResponse<OrderDetail>
                    {
                        Error = error,
                        Success = success,
                        OperatedItemResults = (IEnumerable<CollectionViewItemResult<OrderDetail>>)requestData.OperatingItems
                    };
                },
                () => requestData.OperatingItems.ItemsCreated.ToList<OrderDetail>()));

        }
    }
}
