/// <reference path="typings/c1.mvc.basic.lib.d.ts" />
var CustomCell = /** @class */ (function () {
    function CustomCell(grid, columnIndex, binding, cellClass, options) {
        this._grid = grid;
        this._binding = binding;
        this._columnIndex = columnIndex;
        this._class = cellClass;
        this._options = options;
        this.createCellTemplate();
    }
    CustomCell.prototype.createCellTemplate = function () {
        var _this = this;
        this._grid.formatItem.addHandler(function (grid, args) {
            if (args.panel.cellType === wijmo.grid.CellType.Cell && args.col === _this._columnIndex) {
                var div = wijmo.createElement("<div style='width:50%;height:50%;'></div>");
                div.id = _this._getControlId(args.row, args.col);
                _this._control = new _this._class(div, _this._options);
                if ((_this._control instanceof wijmo.input.ComboBox) || (_this._control instanceof wijmo.input.AutoComplete)) {
                    var _ctrl_1 = _this._control;
                    _ctrl_1.selectedValue = grid.rows[args.row].dataItem[_this._binding];
                    _ctrl_1.textChanged.addHandler(function (s, e) {
                        var editItem = grid.collectionView;
                        editItem.currentEditItem[_this._binding] = s['selectedValue'];
                    });
                    _ctrl_1.gotFocus.addHandler(function (s, e) {
                        var rowIndex = _this._getRowIndexFromControl(s.hostElement.id);
                        if (_this._grid.selection.row != rowIndex) {
                            _this._grid.startEditing(false, rowIndex, _this._columnIndex, true);
                        }
                    });
                    _ctrl_1.hostElement.addEventListener("keydown", function (e) {
                        var _nextElement = _ctrl_1.hostElement.nextElementSibling;
                        if (_nextElement && e.keyCode == 13) {
                            wijmo.Control.getControl(_nextElement).focus();
                        }
                    }, true);
                }
                if (args.cell.children.length > 0) {
                    var children = args.cell.children[0];
                    if (wijmo.Control.getControl(children) === null) {
                        args.cell.removeChild(children);
                    }
                    args.cell.style.padding = '0';
                    args.cell.appendChild(div);
                }
            }
        });
        setTimeout(function () {
            _this._grid.autoSizeRows();
        }, 100);
        //this._grid.startEditing(false, 0, 0, true);        
        this._grid.collectionView.currentItem = null;
        this._grid.selectionChanged.addHandler(this.selectionChanged.bind(this));
    };
    CustomCell.prototype.selectionChanged = function (s, e) {
        if (this._grid) {
            this._grid.startEditing(false, e.row, e.col, true);
            //var _cell = this._grid.cells.getCellElement(e.row, e.col);
            //if (_cell.childElementCount > 0) {
            //    let _ctrl = wijmo.Control.getControl('#' + _cell.children[0].id);
            //    _ctrl.focus();
            //}
        }
        else {
            console.error("Error in grid");
        }
    };
    CustomCell.prototype._getRowIndexFromControl = function (id) {
        var _i = id.indexOf("row");
        return parseInt(id.substr(_i + 3, 1));
    };
    CustomCell.prototype._getGridId = function () {
        return this._grid.hostElement.id;
    };
    CustomCell.prototype._getControlId = function (row, col) {
        return wijmo.getUniqueId(this._getGridId() + "_row" + row + "_col" + col + "_ctrl");
    };
    return CustomCell;
}());
